function area = computeFacetAreaVrep(vrep, dirMatrix, zerotol)
% surface area or facet area of a V-polytope
%
% Syntax: area = computeFacetAreaVrep(vrep, dirMatrix)
%   or    area = computeFacetAreaVrep(vrep)
%
% The first variant calculates a vector of facet areas for all directions
%   in dirMatrix that contains one direction in each row. The second
%   variant calculates the surface area of the polytope. You might use
%   dirMatrix = [] to obtain the same behavior.
%
% computeFacetAreaVrep(..., zerotol) allows to set the tolerance for 
%   underlying algorithms (determining flat polytopes; default in
%   elkZerotol).
%
% See also: computeFacetAreaHrep, computeVolumeVrep,
%   computeProjectionAreaVrep, computeFeretVrep, computeSupportValueVrep

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% Input handling
% default zerotol
if ~exist('zerotol', 'var')
    zerotol = elkZerotol;
end

% % check dimension
% if size(vrep.V, 2) == 3
%     % everything OK, that is the normal case
% elseif size(vrep.V, 2) == 1
%     % this is trivial
%     area = 0;
%     return
% else
%     error('elk:polytope:inputError', ...
%           'Only three dimensional polytopes can be handled');
% end

%% Handle surface calculation (no dir given)
if ~exist('dirMatrix','var') || isempty(dirMatrix)
    hrep = convertVrepToHrep(vrep);
    dirMatrix = hrep.A;
    sumUp = 1;
else
    sumUp = 0;
end

%% do for each facet
area = zeros(1,size(dirMatrix, 1));
nDim = size(vrep.V, 2);
for iFacet = 1:size(dirMatrix, 1)
    % Get support set in direction
    supportVrep = computeSupportSetVrep(vrep, dirMatrix(iFacet, :), zerotol);
    
    % Calculate volume of support set (2-D Volume)
    if size(supportVrep.V, 2) == nDim-1
        area(iFacet) = computeVolumeVrep(supportVrep, zerotol);
    else
        area(iFacet) = 0;
    end
end

if sumUp
    area = sum(area);
end